#!/usr/bin/perl
#
# read a pdb file 
#
use strict;
#use lib qw(/home/luholm/mpidali/);
use mpidali;
my $tmpfile="$$\.tmp";

if($#ARGV<2) { die "Convert PDB entry into internal data format used by Dali.\n\nUSAGE: $0 pdbfilename four-letter-identifier DALIDATDIR\n"; }
my($pdbfile,$short,$DALIDATDIR)=@ARGV;

# lock directory (units.puu, subunits.puu, domains.puu)
&lock();

if($pdbfile =~ /\.gz$/) {
        warn "Detected compressed file\n";
        system("zcat $pdbfile > $tmpfile");
        $pdbfile=$tmpfile;
}
my($x)=&get_type($pdbfile,'list');
if($x ne 'brkfile') { die "$pdbfile is $x not a PDB file\n"; }
if($short!~/^\w{4}$/) { die "invalid identifier $short - must be 4 characters [e.g., 1ppt]\n"; }
&prepare_brkfile($pdbfile,$short,$DALIDATDIR);

# unlock directory
&unlock();

# clean up
system("rm -f $tmpfile");

